Index: font-lock.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/lisp/font-lock.el,v
retrieving revision 1.29
diff -u -r1.29 font-lock.el
--- lisp/font-lock.el	2005/01/26 04:18:15	1.29
+++ lisp/font-lock.el	2005/02/10 02:41:21
@@ -1771,122 +2468,489 @@
       )
     raw-defaults))
 
-(defun font-lock-examine-syntax-table ()
-  ; Computes the value of font-lock-keywords-only for this buffer.
-  (if (eq (syntax-table) (standard-syntax-table))
-      ;; Assume that modes which haven't bothered to install their own
-      ;; syntax table don't do anything syntactically interesting.
-      ;; Really, the standard-syntax-table shouldn't have comments and
-      ;; strings in it, but changing that now might break things.
-      nil
-    ;; else map over the syntax table looking for strings or comments.
-    (let (got-one)
-      ;; XEmacs 20.0 ...
-      (if (fboundp 'map-syntax-table)
-	  (setq got-one
-		(map-syntax-table
-		 #'(lambda (key value)
-		     (memq (char-syntax-from-code value)
-			   '(?\" ?\< ?\> ?\$)))
-		 (syntax-table)))
-	;; older Emacsen.
-	(let ((i (1- (length (syntax-table)))))
-	  (while (>= i 0)
-	    (if (memq (char-syntax i) '(?\" ?\< ?\> ?\$))
-		(setq got-one t i 0))
-	    (setq i (1- i)))))
-      (set (make-local-variable 'font-lock-keywords-only) (not got-one)))))
+;;;###autoload
+(defun font-lock-set-defaults (&optional explicit-defaults)
+  "Set fontification defaults appropriately for this mode.
+
+If EXPLICIT-DEFAULTS is not nil and not t, it is used to compute the
+defaults; else, if `font-lock-defaults' is currently set, it is used;
+else, the symbol naming the major mode is examined for a `font-lock-defaults'
+property.
+
+The value of `font-lock-maximum-decoration' is used to determine which
+set of keywords applies, if more than one exists.
+
+Calling this function multiple times in the same buffer is safe -- this
+function keeps track of whether it has already been called in this buffer, and
+does nothing if so (unless EXPLICIT-DEFAULTS is non-nil).  This allows for
+multiple ways of getting Font Lock properly initialized in a buffer, to deal
+with existing major modes that do not call this function. (For example, Font
+Lock adds this function to `find-file-hooks'.)
+
+Major modes that have any font-lock defaults specified should call this
+function during their initialization process, after they have set
+the variable `major-mode'."
+  ;; Set fontification defaults iff not previously set (or if EXPLICIT-DEFAULTS
+  ;; is specified).
+  (unless (and font-lock-set-defaults (not explicit-defaults))
+    (set (make-local-variable 'font-lock-set-defaults)		t)
+    (set (make-local-variable 'font-lock-cache-state)		nil)
+    (set (make-local-variable 'font-lock-cache-position)	(make-marker))
+    (make-local-variable 'font-lock-fontified)
+    (make-local-variable 'font-lock-multiline)
+    (let* ((defaults (or ;; XEmacs
+		      ;; Explicit defaults given.
+		      (and (not (eq t explicit-defaults))
+			   explicit-defaults)
+		      ;; in case modes decide to set
+		      ;; `font-lock-defaults' themselves,
+		      ;; as in FSF Emacs.
+		      font-lock-defaults
+		      ;; FSF 21.2:
+		      ;; (cdr (assq major-mode font-lock-defaults-alist))
+		      (font-lock-find-font-lock-defaults major-mode)))
+	   (keywords
+	    (font-lock-choose-keywords (nth 0 defaults)
+	     (font-lock-value-in-major-mode font-lock-maximum-decoration)))
+	   (local (cdr (assq major-mode font-lock-keywords-alist)))
+	   (removed-keywords
+	    (cdr-safe (assq major-mode font-lock-removed-keywords-alist))))
+      ;; Previous XEmacs code here.  This dates back at least to 1994 and is
+      ;; undocumented, so there seems no reason to keep it.
+;       (or keywords
+; 	  ;; older way:
+; 	  ;; try to look for a variable `foo-mode-font-lock-keywords',
+; 	  ;; or similar.
+; 	  (let ((major (symbol-name major-mode))
+; 		(try #'(lambda (n)
+; 			 (if (stringp n) (setq n (intern-soft n)))
+; 			 (if (and n
+; 				  (boundp n))
+; 			     n
+; 			   nil))))
+; 	    (setq keywords
+; 		  (symbol-value
+; 		   (or (funcall try (get major-mode 'font-lock-keywords))
+; 		       (funcall try (concat major "-font-lock-keywords"))
+; 		       (funcall try (and (string-match "-mode\\'" major)
+; 					 (concat (substring 
+; 						  major 0 
+; 						  (match-beginning 0))
+; 						 "-font-lock-keywords")))
+; 		       'font-lock-keywords)))))
+      ;; Regexp fontification?
+      (set (make-local-variable 'font-lock-keywords)
+	   (font-lock-compile-keywords (font-lock-eval-keywords keywords)))
+      ;; Local fontification?
+      (while local
+	(font-lock-add-keywords nil (car (car local)) (cdr (car local)))
+	(setq local (cdr local)))
+      (when removed-keywords
+	(font-lock-remove-keywords nil removed-keywords))
+      ;; Syntactic fontification?
+      (when (nth 1 defaults)
+	(set (make-local-variable 'font-lock-keywords-only) t))
+      ;; Case fold during regexp fontification?
+      (when (nth 2 defaults)
+	(set (make-local-variable 'font-lock-keywords-case-fold-search) t))
+      ;; Syntax table for regexp and syntactic fontification?
+      (when (nth 3 defaults)
+	(let ((slist (nth 3 defaults)))
+	  (set (make-local-variable 'font-lock-syntax-table)
+	       (copy-syntax-table (syntax-table)))
+	  (while slist
+	    ;; The character to modify may be a single CHAR or a STRING.
+	    (let ((chars (if (numberp (car (car slist)))
+			     (list (car (car slist)))
+			   (mapcar 'identity (car (car slist)))))
+		  (syntax (cdr (car slist))))
+	      (while chars
+		(modify-syntax-entry (car chars) syntax font-lock-syntax-table)
+		(setq chars (cdr chars)))
+	      (setq slist (cdr slist))))))
+      ;; Syntax function for syntactic fontification?
+      (when (nth 4 defaults)
+	(set (make-local-variable 'font-lock-beginning-of-syntax-function)
+	     (nth 4 defaults)))
+      ;; Variable alist?
+      (dolist (x (nthcdr 5 defaults))
+	(let ((variable (car x)) (value (cdr x)))
+	  (unless (boundp variable)
+	    (set variable nil))		;why ?
+	  (set (make-local-variable variable) value))))))
+
+(defun font-lock-unset-defaults ()
+  "Unset fontification defaults.  See function `font-lock-set-defaults'."
+  (setq font-lock-set-defaults			nil
+	font-lock-keywords			nil
+	font-lock-keywords-only			nil
+	font-lock-keywords-case-fold-search	nil
+	font-lock-syntax-table			nil
+	font-lock-beginning-of-syntax-function	nil)
+  (let* ((defaults (or font-lock-defaults
+		      ;; FSF 21.2:
+		      ;; (cdr (assq major-mode font-lock-defaults-alist))
+		      (font-lock-find-font-lock-defaults major-mode)))
+	 (alist (nthcdr 5 defaults)))
+    (while alist
+      (set (car (car alist)) (default-value (car (car alist))))
+      (setq alist (cdr alist)))))
+
+;;; Colour etc. support.
 
-;; font-lock-set-defaults is in fontl-hooks.el.
+;; FSF has:
 
-;;;###autoload
-(defun font-lock-set-defaults-1 (&optional explicit-defaults)
-  ;; does everything that font-lock-set-defaults does except
-  ;; enable font-lock-mode.  This is called by `font-lock-mode'.
-  ;; Note that the return value is used!
-
-  (if (and font-lock-defaults-computed (not explicit-defaults))
-      ;; nothing to do.
-      nil
-
-    (or font-lock-keywords
-	(let* ((defaults (or (and (not (eq t explicit-defaults))
-				  explicit-defaults)
-			     ;; in case modes decide to set
-			     ;; `font-lock-defaults' themselves,
-			     ;; as in FSF Emacs.
-			     font-lock-defaults
-			     (font-lock-find-font-lock-defaults major-mode)))
-	       (keywords (font-lock-choose-keywords
-			  (nth 0 defaults) font-lock-maximum-decoration)))
-
-	  ;; Keywords?
-	  (setq font-lock-keywords (if (fboundp keywords)
-				       (funcall keywords)
-				     (eval keywords)))
-	  (or font-lock-keywords
-	      ;; older way:
-	      ;; try to look for a variable `foo-mode-font-lock-keywords',
-	      ;; or similar.
-	      (let ((major (symbol-name major-mode))
-		    (try #'(lambda (n)
-			     (if (stringp n) (setq n (intern-soft n)))
-			     (if (and n
-				      (boundp n))
-				 n
-			       nil))))
-		(setq font-lock-keywords 
-		      (symbol-value
-		       (or (funcall try (get major-mode 'font-lock-keywords))
-			   (funcall try (concat major "-font-lock-keywords"))
-			   (funcall try (and (string-match "-mode\\'" major)
-					     (concat (substring 
-						      major 0 
-						      (match-beginning 0))
-						     "-font-lock-keywords")))
-			   'font-lock-keywords)))))
-
-	  ;; Case fold?
-	  (if (>= (length defaults) 3)
-	      (setq font-lock-keywords-case-fold-search (nth 2 defaults))
-	    ;; older way:
-	    ;; look for a property 'font-lock-keywords-case-fold-search on
-	    ;; the major-mode symbol.
-	    (let* ((nonexist (make-symbol ""))
-		   (value (get major-mode 'font-lock-keywords-case-fold-search
-			       nonexist)))
-	      (if (not (eq nonexist value))
-		  (setq font-lock-keywords-case-fold-search value))))
-
-	  ;; Syntactic?
-	  (if (>= (length defaults) 2)
-	      (setq font-lock-keywords-only (nth 1 defaults))
-	    ;; older way:
-	    ;; cleverly examine the syntax table.
-	    (font-lock-examine-syntax-table))
-	   
-	  ;; Syntax table?
-	  (if (nth 3 defaults)
-	      (let ((slist (nth 3 defaults)))
-		(setq font-lock-syntax-table
-		      (copy-syntax-table (syntax-table)))
-		(while slist
-		  (modify-syntax-entry (car (car slist)) (cdr (car slist))
-				       font-lock-syntax-table)
-		  (setq slist (cdr slist)))))
-
-	  ;; Syntax function?
-	  (cond (defaults
-		  (setq font-lock-beginning-of-syntax-function
-			(nth 4 defaults)))
-		(t
-		 ;; older way:
-		 ;; defaults not specified at all, so use `beginning-of-defun'.
-		 (setq font-lock-beginning-of-syntax-function
-		       'beginning-of-defun)))))
+;; Originally face attributes were specified via `font-lock-face-attributes'.
+;; Users then changed the default face attributes by setting that variable.
+;; However, we try and be back-compatible and respect its value if set except
+;; for faces where M-x customize has been used to save changes for the face.
+
+;;(when (boundp 'font-lock-face-attributes)
+;; ...
+
+;; Since we never had it, we don't need to be backwards-compatible.
+
+
+(defconst font-lock-face-list
+  '(font-lock-comment-face
+    font-lock-string-face
+    font-lock-doc-string-face
+    font-lock-keyword-face
+    font-lock-builtin-face
+    font-lock-function-name-face
+    font-lock-variable-name-face
+    font-lock-type-face
+    font-lock-constant-face
+    font-lock-preprocessor-face
+    font-lock-warning-face))
+
+;; These are our old definitions, quite different from FSF.
+;; I've temporarily substituted the FSF definitions to see if I like them.
+
+; (defface font-lock-comment-face
+;   '((((class color) (background dark)) (:foreground "gray80"))
+;     ;; blue4 is hardly different from black on windows.
+;     (((class color) (background light) (type mswindows)) (:foreground "blue"))
+;     (((class color) (background light)) (:foreground "blue4"))
+;     (((class grayscale) (background light))
+;      (:foreground "DimGray" :bold t :italic t))
+;     (((class grayscale) (background dark))
+;      (:foreground "LightGray" :bold t :italic t))
+;     (t (:bold t)))
+;   "Font Lock mode face used to highlight comments."
+;:group 'font-lock-faces)
+
+; (defface font-lock-string-face
+;   '((((class color) (background dark)) (:foreground "tan"))
+;     (((class color) (background light)) (:foreground "green4"))
+;     (((class grayscale) (background light)) (:foreground "DimGray" :italic t))
+;     (((class grayscale) (background dark)) (:foreground "LightGray" :italic t))
+;     (t (:bold t)))
+;   "Font Lock mode face used to highlight strings."
+;:group 'font-lock-faces)
+
+; (defface font-lock-doc-string-face
+;   '((((class color) (background dark)) (:foreground "light coral"))
+;     (((class color) (background light)) (:foreground "green4"))
+;     (t (:bold t)))
+;   "Font Lock mode face used to highlight documentation strings.
+; This is currently supported only in Lisp-like modes, which are those
+; with \"lisp\" or \"scheme\" in their name.  You can explicitly make
+; a mode Lisp-like by putting a non-nil `font-lock-lisp-like' property
+; on the major mode's symbol."
+;:group 'font-lock-faces)
+
+; (defface font-lock-keyword-face
+;   '((((class color) (background dark)) (:foreground "cyan"))
+;     ;; red4 is hardly different from black on windows.
+;     (((class color) (background light) (type mswindows)) (:foreground "red"))
+;     (((class color) (background light)) (:foreground "red4"))
+;     (((class grayscale) (background light)) (:foreground "LightGray" :bold t))
+;     (((class grayscale) (background dark)) (:foreground "DimGray" :bold t))
+;     (t (:bold t)))
+;   "Font Lock mode face used to highlight keywords."
+;:group 'font-lock-faces)
+
+; (defface font-lock-builtin-face
+;   '((((class color) (background light)) (:foreground "Purple"))
+;     (((class color) (background dark)) (:foreground "Cyan"))
+;     (((class grayscale) (background light)) (:foreground "LightGray" :bold t))
+;     (((class grayscale) (background dark)) (:foreground "DimGray" :bold t))
+;     (t (:bold t)))
+;   "Font Lock mode face used to highlight builtins."
+;:group 'font-lock-faces)
+
+; (defface font-lock-function-name-face
+;   '((((class color) (background dark)) (:foreground "aquamarine"))
+;     ;; brown4 is hardly different from black on windows.
+;     ;; I changed it to red because IMO it's pointless and ugly to
+;     ;; use a million slightly different colors for niggly syntactic
+;     ;; differences. --ben
+;     (((class color) (background light) (type mswindows)) (:foreground "red"))
+;     (((class color) (background light)) (:foreground "brown4"))
+;     (t (:bold t :underline t)))
+;   "Font Lock mode face used to highlight function names."
+;:group 'font-lock-faces)
+
+; (defface font-lock-variable-name-face
+;   '((((class color) (background dark)) (:foreground "cyan3"))
+;     (((class color) (background light)) (:foreground "magenta4"))
+;     (((class grayscale) (background light))
+;      (:foreground "Gray90" :bold t :italic t))
+;     (((class grayscale) (background dark))
+;      (:foreground "DimGray" :bold t :italic t))
+;     (t (:underline t)))
+;   "Font Lock mode face used to highlight variable names."
+;:group 'font-lock-faces)
+
+; (defface font-lock-type-face
+;   '((((class color) (background dark)) (:foreground "wheat"))
+;     (((class color) (background light)) (:foreground "steelblue"))
+;     (((class grayscale) (background light)) (:foreground "Gray90" :bold t))
+;     (((class grayscale) (background dark)) (:foreground "DimGray" :bold t))
+;     (t (:bold t)))
+;   "Font Lock mode face used to highlight types."
+;:group 'font-lock-faces)
+
+; (defface font-lock-constant-face
+;   '((((class color) (background light)) (:foreground "CadetBlue"))
+;     (((class color) (background dark)) (:foreground "Aquamarine"))
+;     (((class grayscale) (background light))
+;      (:foreground "LightGray" :bold t :underline t))
+;     (((class grayscale) (background dark))
+;      (:foreground "Gray50" :bold t :underline t))
+;     (t (:bold t :underline t)))
+;   "Font Lock mode face used to highlight constants and labels."
+;:group 'font-lock-faces)
+
+; (defface font-lock-reference-face
+;   '((((class color) (background dark)) (:foreground "cadetblue2"))
+;     (((class color) (background light)) (:foreground "red3"))
+;     (((class grayscale) (background light))
+;      (:foreground "LightGray" :bold t :underline t))
+;     (((class grayscale) (background dark))
+;      (:foreground "Gray50" :bold t :underline t)))
+;   "Font Lock mode face used to highlight references."
+;:group 'font-lock-faces)
+
+; (defface font-lock-preprocessor-face
+;   '((((class color) (background dark)) (:foreground "steelblue1"))
+;     (((class color) (background light)) (:foreground "blue3"))
+;     (t (:underline t)))
+;   "Font Lock Mode face used to highlight preprocessor conditionals."
+;:group 'font-lock-faces)
+
+; (defface font-lock-warning-face
+;   '((((class color) (background light)) (:foreground "Red" :bold t))
+;     (((class color) (background dark)) (:foreground "Pink" :bold t))
+;     (t (:inverse-video t :bold t)))
+;   "Font Lock mode face used to highlight warnings."
+;:group 'font-lock-faces)
+
+(defface font-lock-comment-face
+  '((((type tty pc) (class color) (background light)) (:foreground "red"))
+    (((type tty pc) (class color) (background dark)) (:foreground "red1"))
+    (((class grayscale) (background light))
+     (:foreground "DimGray" :bold t :italic t))
+    (((class grayscale) (background dark))
+     (:foreground "LightGray" :bold t :italic t))
+    (((class color) (background light)) (:foreground "Firebrick"))
+    (((class color) (background dark)) (:foreground "chocolate1"))
+    (t (:bold t :italic t)))
+  "Font Lock mode face used to highlight comments."
+:group 'font-lock-faces)
+
+(defface font-lock-string-face
+  '((((type tty) (class color)) (:foreground "green"))
+    (((class grayscale) (background light)) (:foreground "DimGray" :italic t))
+    (((class grayscale) (background dark)) (:foreground "LightGray" :italic t))
+    (((class color) (background light)) (:foreground "RosyBrown"))
+    (((class color) (background dark)) (:foreground "LightSalmon"))
+    (t (:italic t)))
+  "Font Lock mode face used to highlight strings."
+:group 'font-lock-faces)
+
+(defface font-lock-doc-string-face
+  '((t :inherit font-lock-string-face))
+  "Font Lock mode face used to highlight documentation strings.
+This is currently supported only in Lisp-like modes, which are those
+with \"lisp\" or \"scheme\" in their name.  You can explicitly make
+a mode Lisp-like by putting a non-nil `font-lock-lisp-like' property
+on the major mode's symbol."
+:group 'font-lock-faces)
+
+(defface font-lock-keyword-face
+  '((((type tty) (class color)) (:foreground "cyan" :weight bold))
+    (((class grayscale) (background light)) (:foreground "LightGray" :bold t))
+    (((class grayscale) (background dark)) (:foreground "DimGray" :bold t))
+    (((class color) (background light)) (:foreground "Purple"))
+    (((class color) (background dark)) (:foreground "Cyan"))
+    (t (:bold t)))
+  "Font Lock mode face used to highlight keywords."
+:group 'font-lock-faces)
+
+(defface font-lock-builtin-face
+  '((((type tty) (class color)) (:foreground "blue" :weight light))
+    (((class grayscale) (background light)) (:foreground "LightGray" :bold t))
+    (((class grayscale) (background dark)) (:foreground "DimGray" :bold t))
+    (((class color) (background light)) (:foreground "Orchid"))
+    (((class color) (background dark)) (:foreground "LightSteelBlue"))
+    (t (:bold t)))
+  "Font Lock mode face used to highlight builtins."
+:group 'font-lock-faces)
+
+(defface font-lock-function-name-face
+  '((((type tty) (class color)) (:foreground "blue" :weight bold))
+    (((class color) (background light)) (:foreground "Blue"))
+    (((class color) (background dark)) (:foreground "LightSkyBlue"))
+    (t (:inverse-video t :bold t)))
+  "Font Lock mode face used to highlight function names."
+:group 'font-lock-faces)
+
+(defface font-lock-variable-name-face
+  '((((type tty) (class color)) (:foreground "yellow" :weight light))
+    (((class grayscale) (background light))
+     (:foreground "Gray90" :bold t :italic t))
+    (((class grayscale) (background dark))
+     (:foreground "DimGray" :bold t :italic t))
+    (((class color) (background light)) (:foreground "DarkGoldenrod"))
+    (((class color) (background dark)) (:foreground "LightGoldenrod"))
+    (t (:bold t :italic t)))
+  "Font Lock mode face used to highlight variable names."
+:group 'font-lock-faces)
 
-    (setq font-lock-cache-position (make-marker))
-    (setq font-lock-defaults-computed t)))
+(defface font-lock-type-face
+  '((((type tty) (class color)) (:foreground "green"))
+    (((class grayscale) (background light)) (:foreground "Gray90" :bold t))
+    (((class grayscale) (background dark)) (:foreground "DimGray" :bold t))
+    (((class color) (background light)) (:foreground "ForestGreen"))
+    (((class color) (background dark)) (:foreground "PaleGreen"))
+    (t (:bold t :underline t)))
+  "Font Lock mode face used to highlight type and classes."
+:group 'font-lock-faces)
+
+(defface font-lock-constant-face
+  '((((type tty) (class color)) (:foreground "magenta"))
+    (((class grayscale) (background light))
+     (:foreground "LightGray" :bold t :underline t))
+    (((class grayscale) (background dark))
+     (:foreground "Gray50" :bold t :underline t))
+    (((class color) (background light)) (:foreground "CadetBlue"))
+    (((class color) (background dark)) (:foreground "Aquamarine"))
+    (t (:bold t :underline t)))
+  "Font Lock mode face used to highlight constants and labels."
+:group 'font-lock-faces)
+
+(defface font-lock-preprocessor-face
+  '((((class color) (background dark)) (:foreground "steelblue1"))
+    (((class color) (background light)) (:foreground "blue3"))
+    (t (:underline t)))
+  "Font Lock Mode face used to highlight preprocessor conditionals."
+:group 'font-lock-faces)
+
+(defface font-lock-warning-face
+  '((((type tty) (class color)) (:foreground "red"))
+    (((class color) (background light)) (:foreground "Red" :bold t))
+    (((class color) (background dark)) (:foreground "Pink" :bold t))
+    (t (:inverse-video t :bold t)))
+  "Font Lock mode face used to highlight warnings."
+:group 'font-lock-faces)
+
+;; Backwards-compatible crud.  XEmacs only.
+
+(defun font-lock-recompute-variables ()
+  ;; Is this a Draconian thing to do?
+  (mapc #'(lambda (buffer)
+	    (with-current-buffer buffer
+	      (font-lock-mode 0)
+	      (font-lock-set-defaults t)))
+	(buffer-list)))
+
+(defun font-lock-reset-all-faces ()
+  (dolist (face font-lock-face-list)
+    (face-spec-set face (get face 'face-defface-spec))))
+
+(defun font-lock-use-default-fonts ()
+  "Reset the font-lock faces to a default set of fonts."
+  (interactive)
+  ;; #### !!!!
+  (font-lock-reset-all-faces))
+
+(defun font-lock-use-default-colors ()
+  "Reset the font-lock faces to a default set of colors."
+  (interactive)
+  ;; #### !!!!
+  (font-lock-reset-all-faces))
+
+(defun font-lock-use-default-minimal-decoration ()
+  "Reset the font-lock patterns to a fast, minimal set of decorations."
+  (and font-lock-maximum-decoration
+       (setq font-lock-maximum-decoration nil)
+       (font-lock-recompute-variables)))
+
+(defun font-lock-use-default-maximal-decoration ()
+  "Reset the font-lock patterns to a larger set of decorations."
+  (and (not (eq t font-lock-maximum-decoration))
+       (setq font-lock-maximum-decoration t)
+       (font-lock-recompute-variables)))
+
+;;; End of Colour etc. support.
+
+;;; Menu support.
+
+;;; FSF writes:
+
+;; This section of code is commented out because Emacs does not have real menu
+;; buttons.  (We can mimic them by putting "( ) " or "(X) " at the beginning of
+;; the menu entry text, but with Xt it looks both ugly and embarrassingly
+;; amateur.)  If/When Emacs gets real menus buttons, put in menu-bar.el after
+;; the entry for "Text Properties" something like:
+
+;; We DO have real menu buttons, and all the code in this section seems to
+;; mimic the option menu.
+
+;; ...
+
+;;; End of Menu support.
+
+;;; Various regexp information shared by several modes.
+;;; Information specific to a single mode should go in its load library.
+
+;; Font Lock support for C, C++, Objective-C and Java modes will one day be in
+;; some cc-font.el (and required by cc-mode.el).  However, the below function
+;; should stay in font-lock.el, since it is used by other libraries.  sm.
+
+(defun font-lock-match-c-style-declaration-item-and-skip-to-next (limit)
+  "Match, and move over, any declaration/definition item after point.
+Matches after point, but ignores leading whitespace and `*' characters.
+Does not move further than LIMIT.
+
+The expected syntax of a declaration/definition item is `word' (preceded by
+optional whitespace and `*' characters and proceeded by optional whitespace)
+optionally followed by a `('.  Everything following the item (but belonging to
+it) is expected to by skip-able by `scan-sexps', and items are expected to be
+separated with a `,' and to be terminated with a `;'.
+
+Thus the regexp matches after point:	word (
+					^^^^ ^
+Where the match subexpressions are:	  1  2
+
+The item is delimited by (match-beginning 1) and (match-end 1).
+If (match-beginning 2) is non-nil, the item is followed by a `('.
+
+This function could be MATCHER in a MATCH-ANCHORED `font-lock-keywords' item."
+  (when (looking-at "[ \t*]*\\(\\sw+\\)[ \t]*\\((\\)?")
+    (save-match-data
+      (condition-case nil
+	  (save-restriction
+	    ;; Restrict to the end of line, currently guaranteed to be LIMIT.
+	    (narrow-to-region (point-min) limit)
+	    (goto-char (match-end 1))
+	    ;; Move over any item value, etc., to the next item.
+	    (while (not (looking-at "[ \t]*\\(\\(,\\)\\|;\\|$\\)"))
+	      (goto-char (or (scan-sexps (point) 1) (point-max))))
+	    (goto-char (match-end 2)))
+	(error t)))))
 
 
 ;;;;;;;;;;;;;;;;;;;;;;         keywords         ;;;;;;;;;;;;;;;;;;;;;;
@@ -1901,73 +2965,17 @@
 ;; for SYNTAX-BEGIN.  Thus the calculation of the cache is usually
 ;; faster but not infallible, so we risk mis-fontification.  --sm.
 
-(put 'c-mode 'font-lock-defaults 
-     '((c-font-lock-keywords
-	c-font-lock-keywords-1 c-font-lock-keywords-2 c-font-lock-keywords-3)
-       nil nil ((?_ . "w")) beginning-of-defun))
-(put 'c++-c-mode 'font-lock-defaults 'c-mode)
-(put 'elec-c-mode 'font-lock-defaults 'c-mode)
-
-(put 'c++-mode 'font-lock-defaults
-     '((c++-font-lock-keywords
-	c++-font-lock-keywords-1 c++-font-lock-keywords-2
-	c++-font-lock-keywords-3)
-       nil nil ((?_ . "w") (?~ . "w")) beginning-of-defun))
-
-(put 'java-mode 'font-lock-defaults 
-     '((java-font-lock-keywords
-	java-font-lock-keywords-1 java-font-lock-keywords-2
-	java-font-lock-keywords-3)
-       nil nil ((?_ . "w")) beginning-of-defun
-       (font-lock-mark-block-function . mark-defun)))
-
-(put 'lisp-mode 'font-lock-defaults
-     '((lisp-font-lock-keywords
-	lisp-font-lock-keywords-1 lisp-font-lock-keywords-2)
-       nil nil
-       ((?: . "w") (?- . "w") (?* . "w") (?+ . "w") (?. . "w") (?< . "w")
-	(?> . "w") (?= . "w") (?! . "w") (?? . "w") (?$ . "w") (?% . "w")
-	(?_ . "w") (?& . "w") (?~ . "w") (?^ . "w") (?/ . "w"))
-       beginning-of-defun))
-(put 'emacs-lisp-mode 'font-lock-defaults 'lisp-mode)
-(put 'lisp-interaction-mode 'font-lock-defaults 'lisp-mode)
-
-(put 'scheme-mode 'font-lock-defaults
-     '(scheme-font-lock-keywords
-       nil t
-       ((?: . "w") (?- . "w") (?* . "w") (?+ . "w") (?. . "w") (?< . "w")
-	(?> . "w") (?= . "w") (?! . "w") (?? . "w") (?$ . "w") (?% . "w")
-	(?_ . "w") (?& . "w") (?~ . "w") (?^ . "w") (?/ . "w"))
-       beginning-of-defun))
-(put 'inferior-scheme-mode 'font-lock-defaults 'scheme-mode)
-(put 'scheme-interaction-mode 'font-lock-defaults 'scheme-mode)
-
-(put 'tex-mode 'font-lock-defaults
-     ;; For TeX modes we could use `backward-paragraph' for the same reason.
-     '(tex-font-lock-keywords nil nil ((?$ . "\""))))
-;; the nine billion names of TeX mode...
-(put 'bibtex-mode	'font-lock-defaults 'tex-mode)
-(put 'plain-tex-mode	'font-lock-defaults 'tex-mode)
-(put 'slitex-tex-mode	'font-lock-defaults 'tex-mode)
-(put 'SliTeX-mode	'font-lock-defaults 'tex-mode)
-(put 'slitex-mode	'font-lock-defaults 'tex-mode)
-(put 'latex-tex-mode	'font-lock-defaults 'tex-mode)
-(put 'LaTex-tex-mode	'font-lock-defaults 'tex-mode)
-(put 'latex-mode        'font-lock-defaults 'tex-mode)
-(put 'LaTeX-mode        'font-lock-defaults 'tex-mode)
-(put 'japanese-LaTeX-mode 'font-lock-defaults 'tex-mode)
-(put 'japanese-SliTeX-mode 'font-lock-defaults 'tex-mode)
-(put 'FoilTeX-mode	'font-lock-defaults 'tex-mode)
-(put 'LATeX-MoDe	'font-lock-defaults 'tex-mode)
-(put 'lATEx-mODe	'font-lock-defaults 'tex-mode)
-;; ok, this is getting a bit silly ...
-(put 'eDOm-xETAl	'font-lock-defaults 'tex-mode)
-
 ;;; Various regexp information shared by several modes.
 ;;; Information specific to a single mode should go in its load library.
 
+
+;; Lisp.
+
 (defconst lisp-font-lock-keywords-1
   (list
+   ;;
+   ;; Definitions.
+   ;;
    ;; Anything not a function or type declaration is fontified as a
    ;; variable.  It would be cleaner to allow preceding whitespace, but it
    ;; would also be about five times slower.  We used to fontify unknown
@@ -1977,16 +2985,15 @@
    ;; different, which looks better.
    (list (concat
 	  "^(\\(" lisp-function-and-type-regexp
-	  ;; Former variable declarations, but woefully inadequate.
-	  ;; "\\|def\\(const\\(\\|ant\\)\\|ine-key\\(\\|-after\\)\\|"
-	  ;; "var\\|custom\\)"
-	  ;; Everything else is a variable declaration.
-	  ;; anything else is a variable
+	  ;; Former variable declarations (FSF 21.2), but woefully inadequate.
+	  ;; "\\(const\\(ant\\)?\\|custom\\|face\\|parameter\\|var\\)\\|"
+	  ;; Anything else is a variable.
 	  "\\|def\\([^ \t\n\(\)]+\\)"
-	  ;; make sure we are at end of word.
+	  ;; Make sure we are at end of word.
 	  "\\)\\>"
 	  ;; Any whitespace following and declared object.
 	  "[ \t'\(]*"
+	  ;; FSF 21.2: "\\(setf[ \t]+\\sw+)\\|\\sw+\\)?")
 	  "\\([^ \t\n\(\)]+\\)?")
 	 ;; Note about numbering:  #1 is the grouping around the whole
 	 ;; keyword.  #2 - #4 are in lisp-function-and-type-regexp.
